%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0
%global with_trans %{!?_without_trans:1}%{?_without_trans:0}
%global distro Red Hat

Name:             openstack-nova
# Liberty semver reset
# https://review.openstack.org/#/q/I6a35fa0dda798fad93b804d00a46af80f08d475c,n,z
Epoch:            1
Version:          14.1.0
Release:          35%{?dist}
Summary:          OpenStack Compute (nova)

License:          ASL 2.0
URL:              http://openstack.org/projects/compute/
Source0:          https://tarballs.openstack.org/nova/nova-%{upstream_version}.tar.gz

Source1:          nova-dist.conf
Source6:          nova.logrotate

Source10:         openstack-nova-api.service
Source11:         openstack-nova-cert.service
Source12:         openstack-nova-compute.service
Source13:         openstack-nova-network.service
Source15:         openstack-nova-scheduler.service
Source18:         openstack-nova-xvpvncproxy.service
Source19:         openstack-nova-console.service
Source20:         openstack-nova-consoleauth.service
Source25:         openstack-nova-metadata-api.service
Source26:         openstack-nova-conductor.service
Source27:         openstack-nova-cells.service
Source28:         openstack-nova-spicehtml5proxy.service
Source29:         openstack-nova-novncproxy.service
Source31:         openstack-nova-serialproxy.service
Source32:         openstack-nova-os-compute-api.service

Source21:         nova-polkit.pkla
Source23:         nova-polkit.rules
Source22:         nova-ifc-template
Source24:         nova-sudoers
Source30:         openstack-nova-novncproxy.sysconfig
Source33:         nova-placement-api.conf

Source35:         nova_migration-sudoers
Source36:         nova-ssh-config
Source37:         nova-migration-wrapper
Source38:         nova_migration_identity
Source39:         nova_migration_authorized_keys
Source40:         nova_migration-rootwrap.conf
Source41:         nova_migration-rootwrap_cold_migration

# patches_ignore=DROP-IN-RPM
# patches_base=14.1.0
#
Patch0001: 0001-libvirt-refactor-console-device-creation-methods.patch
Patch0002: 0002-libvirt-Acquire-TCP-ports-for-console-during-live-mi.patch
Patch0003: 0003-add-host-to-vif.py-set_config_-functions.patch
Patch0004: 0004-convert-libvirt-driver-to-use-os-vif-for-vhost-user-.patch
Patch0005: 0005-libvirt-workaround-findmnt-behaviour-change.patch
Patch0006: 0006-libvirt-Pass-Host-instead-of-Driver-to-volume-driver.patch
Patch0007: 0007-libvirt-Call-host-connection-callbacks-asynchronousl.patch
Patch0008: 0008-libvirt-Pass-instance-to-connect_volume-and-disconne.patch
Patch0009: 0009-libvirt-Fix-races-with-nfs-volume-mount-umount.patch
Patch0010: 0010-os-vif-convert-libvirt-driver-to-use-os-vif-for-fast.patch
Patch0011: 0011-contrail-add-vrouter-VIF-plugin-type-support.patch
Patch0012: 0012-neutron-retrieve-physical-network-name-from-a-multi-.patch
Patch0013: 0013-Revert-MTU-hacks-for-bug-1623876.patch
Patch0014: 0014-network-remove-support-of-vhost-fast-path.patch
Patch0015: 0015-Pass-MTU-into-os-vif-Network-object.patch
Patch0016: 0016-Make-unit-tests-work-with-os-vif-1.4.0.patch
Patch0017: 0017-libvirt-remove-redundant-and-broken-iscsi-volume-tes.patch
Patch0018: 0018-ovs-hybrid-should-permanently-keep-MAC-entries.patch
Patch0019: 0019-libvirt-update-LibvirtConfigGuestDeviceAddress-to-pr.patch
Patch0020: 0020-libvirt-set-full-description-of-the-controller-used-.patch
Patch0021: 0021-libvirt-rearange-how-scsi-controller-is-defined.patch
Patch0022: 0022-libvirt-update-logic-to-configure-device-for-scsi-co.patch
Patch0023: 0023-libvirt-update-the-logic-to-configure-volume-with-sc.patch
Patch0024: 0024-libvirt-remove-hack-for-dom.vcpus-returning-None.patch
Patch0025: 0025-libvirt-fix-vCPU-usage-reporing-for-LXC-QEMU-guests.patch
Patch0026: 0026-scheduler-quick-fail-on-CPUs-pinning-conflicts-durin.patch
Patch0027: 0027-Fix-disk-size-during-live-migration-with-disk-over-c.patch
Patch0028: 0028-Add-format_dom-for-PCI-device-addresses.patch
Patch0029: 0029-Fixes-Not-enough-available-memory-log-message.patch
Patch0030: 0030-Set-server-status-to-ERROR-if-rebuild-failed.patch
Patch0031: 0031-libvirt-bandwidth-param-should-be-set-in-guest-migra.patch
Patch0032: 0032-libvirt-Don-t-VIR_MIGRATE_NON_SHARED_INC-without-mig.patch
Patch0033: 0033-libvirt-Test-disk-creation-in-test_hard_reboot.patch
Patch0034: 0034-libvirt-Re-initialise-volumes-encryptors-and-vifs-on.patch
Patch0035: 0035-Don-t-wait-for-vif-plug-events-during-_hard_reboot.patch
Patch0036: 0036-Save-updated-libvirt-domain-XML-after-swapping-volum.patch
Patch0037: 0037-Refine-waiting-for-vif-plug-events-during-_hard_rebo.patch
Patch0038: 0038-Do-not-attempt-to-load-osinfo-if-we-do-not-have-os_d.patch
Patch0039: 0039-libvirt-cleanup-network-volume-driver-auth-config.patch
Patch0040: 0040-libvirt-prefer-cinder-rbd-auth-values-over-nova.conf.patch
Patch0041: 0041-live-mig-keep-disk-device-address-same.patch
Patch0042: 0042-libvirt-disconnect-volume-from-host-during-detach.patch
Patch0043: 0043-Refactor-a-test-method-including-7-test-cases.patch
Patch0044: 0044-Do-not-attempt-volume-swap-when-guest-is-stopped-sus.patch
Patch0045: 0045-Revert-Refine-waiting-for-vif-plug-events-during-_ha.patch
Patch0046: 0046-Avoid-lazy-load-error-when-getting-instance-AZ.patch
Patch0047: 0047-Use-proper-user-and-tenant-in-the-owner-section-of-l.patch
Patch0048: 0048-Save-admin-password-to-sysmeta-in-libvirt-driver.patch
Patch0049: 0049-only-increment-disk-address-unit-for-scsi-devices.patch
Patch0050: 0050-libvirt-Allow-to-specify-granular-CPU-feature-flags.patch
Patch0051: 0051-libvirt-move-version-to-string-in-utils.patch
Patch0052: 0052-libvirt-refactor-get_base_config-to-accept-host-arg.patch
Patch0053: 0053-libvirt-fix-wrong-driver-name-for-vhostuser-interfac.patch
Patch0054: 0054-libvirt-add-support-for-virtio-net-rx-tx-queue-sizes.patch
Patch0055: 0055-libvirt-Report-the-allocated-size-of-preallocated-fi.patch
Patch0056: 0056-conf-Remove-duplicate-oslo_config-types-import.patch
Patch0057: 0057-libvirt-fix-setting-tx_queue_size-when-rx_queue_size.patch
Patch0058: 0058-libvirt-Make-cpu_model_extra_flags-case-insensitive-.patch
Patch0059: 0059-libvirt-Lift-the-restriction-of-choices-for-cpu_mode.patch
Patch0060: 0060-Refactor-a-test-method-including-3-test-cases.patch
Patch0061: 0061-libvirt-Block-swap-volume-attempts-with-encrypted-vo.patch
Patch0062: 0062-Add-CPUWeigher.patch
Patch0063: 0063-conf-Allow-users-to-unset-keymap-options.patch
Patch0064: 0064-libvirt-slow-live-migration-to-ensure-network-is-rea.patch
Patch0065: 0065-add-mtu-to-libvirt-xml-for-ethernet-and-bridge-types.patch
Patch0066: 0066-Revert-libvirt-slow-live-migration-to-ensure-network.patch
Patch0067: 0067-libvirt-skip-setting-rx-tx-queue-sizes-for-not-virto.patch
Patch0068: 0068-linux_net-allow-for-creation-of-multiqueue-taps.patch
Patch0069: 0069-vif-allow-for-creation-of-multiqueue-taps-in-vrouter.patch
Patch0070: 0070-libvirt-Rename-Backend-snapshot-and-image.patch
Patch0071: 0071-Add-context-param-to-confirm_migration-virt-call.patch
Patch0072: 0072-Ensure-that-instance-directory-is-removed-after-succ.patch
Patch0073: 0073-libvirt-do-not-remove-inst_base-when-volume-backed-d.patch
Patch0074: 0074-libvirt-check-image-type-before-removing-snapshots-i.patch
Patch0075: 0075-Prepare-functional-tests-for-live-migration-support.patch
Patch0076: 0076-Handle-volume-API-failure-in-_post_live_migration.patch
Patch0077: 0077-hardware-fix-hugepages-memory-usage-per-intances.patch
Patch0078: 0078-hardware-fix-memory-check-usage-for-small-large-page.patch
Patch0079: 0079-Support-qemu-2.10.patch
Patch0080: 0080-Refactor-_build_device_metadata.patch
Patch0081: 0081-Consider-hostdev-devices-when-building-metadata.patch
Patch0082: 0082-LM-Make-quick-fail-on-CPU-pinning-conflict-configura.patch

BuildArch:        noarch
BuildRequires:    intltool
BuildRequires:    python2-devel
BuildRequires:    python-sphinx
BuildRequires:    python-oslo-cache
BuildRequires:    python-oslo-sphinx
BuildRequires:    python-setuptools
BuildRequires:    python-netaddr
BuildRequires:    python-pbr
BuildRequires:    python-d2to1
BuildRequires:    python-six
BuildRequires:    python-oslo-i18n
BuildRequires:    python-cryptography >= 1.0

Requires:         openstack-nova-compute = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-cert = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-scheduler = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-api = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-network = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-conductor = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-console = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-cells = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-novncproxy = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-placement-api = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-migration = %{epoch}:%{version}-%{release}


%description
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

%package common
Summary:          Components common to all OpenStack Nova services

Requires:         python-nova = %{epoch}:%{version}-%{release}
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Requires(pre):    shadow-utils
BuildRequires:    systemd
# Required to build nova.conf.sample
BuildRequires:    python-castellan >= 0.4.0
BuildRequires:    python-glanceclient
BuildRequires:    python-keystonemiddleware
BuildRequires:    python-lxml
BuildRequires:    python-microversion-parse >= 0.1.3
BuildRequires:    python-os-brick
BuildRequires:    python-oslo-db
BuildRequires:    python-oslo-reports
BuildRequires:    python-oslo-service
BuildRequires:    python-oslo-versionedobjects
BuildRequires:    python-paramiko
BuildRequires:    python-websockify
# Required to compile translation files
BuildRequires:    python-babel

# remove old service subpackage
Obsoletes: %{name}-objectstore


%description common
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains scripts, config and dependencies shared
between all the OpenStack nova services.


%package compute
Summary:          OpenStack Nova Virtual Machine control service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         curl
Requires:         iscsi-initiator-utils
Requires:         iptables iptables-ipv6
Requires:         ipmitool
Requires:         python-libguestfs
Requires:         libvirt-python
Requires:         libvirt-daemon-kvm
Requires:         /usr/bin/virsh
%if 0%{?rhel}==0
Requires:         libvirt-daemon-lxc
%endif
Requires:         openssh-clients
Requires:         rsync
Requires:         lvm2
Requires:         python-cinderclient >= 1.6.0
Requires(pre):    qemu-kvm >= 2.3.0
Requires:         genisoimage
Requires:         bridge-utils
Requires:         sg3_utils
Requires:         sysfsutils
Requires:         libosinfo

%description compute
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for controlling Virtual Machines.


%package network
Summary:          OpenStack Nova Network control service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         radvd
Requires:         bridge-utils
Requires:         dnsmasq
Requires:         dnsmasq-utils
Requires:         ebtables
Requires:         conntrack-tools

%description network
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for controlling networking.


%package scheduler
Summary:          OpenStack Nova VM distribution service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description scheduler
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the service for scheduling where
to run Virtual Machines in the cloud.


%package cert
Summary:          OpenStack Nova certificate management service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description cert
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for managing certificates.


%package api
Summary:          OpenStack Nova API services

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-cinderclient >= 1.6.0

%description api
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing programmatic access.

%package conductor
Summary:          OpenStack Nova Conductor services

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description conductor
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing database access for
the compute service

%package console
Summary:          OpenStack Nova console access services

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description console
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing
console access services to Virtual Machines.

%package cells
Summary:          OpenStack Nova Cells services

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description cells
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova Cells service providing additional
scaling and (geographic) distribution for compute services.

%package novncproxy
Summary:          OpenStack Nova noVNC proxy service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         novnc
Requires:         python-websockify


%description novncproxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova noVNC Proxy service that can proxy
VNC traffic over browser websockets connections.

%package spicehtml5proxy
Summary:          OpenStack Nova Spice HTML5 console access service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description spicehtml5proxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing the
spice HTML5 console access service to Virtual Machines.

%package serialproxy
Summary:          OpenStack Nova serial console access service

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description serialproxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing the
serial console access service to Virtual Machines.

%package placement-api
Summary:          OpenStack Nova Placement APIservice

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         httpd
Requires:         mod_wsgi

%description placement-api
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova placement service, which will initially
allow for the management of resource providers.

%package migration
Summary:          OpenStack Nova Migration

Requires:         openstack-nova-compute = %{epoch}:%{version}-%{release}

%description migration
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains scripts and config to support VM migration in Nova.

%package -n       python-nova
Summary:          Nova Python libraries

Requires:         openssl
# Require openssh for ssh-keygen
Requires:         openssh
Requires:         sudo

Requires:         python-paramiko

Requires:         python-eventlet >= 0.17.4
Requires:         python-iso8601
Requires:         python-netaddr
Requires:         python-lxml
Requires:         python-anyjson
Requires:         python-boto
Requires:         python-cheetah
Requires:         python-ldap
Requires:         python-stevedore >= 1.16.0

Requires:         python-memcached

Requires:         python-sqlalchemy >= 1.0.10
Requires:         python-migrate >= 0.9.6
Requires:         python-alembic >= 0.8.0

Requires:         python-paste
Requires:         python-paste-deploy
Requires:         python-routes
Requires:         python-webob

Requires:         python-babel
Requires:         python-castellan >= 0.4.0
Requires:         python-cryptography >= 1.0
Requires:         python-glanceclient >= 2.0.0
Requires:         python-keystonemiddleware >= 4.0.0
Requires:         python-keystoneauth1 >= 2.10.0
Requires:         python-jinja2
Requires:         python-jsonschema
Requires:         python-microversion-parse >= 0.1.2
Requires:         python-neutronclient >= 5.0.0
Requires:         python-novaclient >= 2.30.1
Requires:         python-os-brick
Requires:         python-oslo-cache >= 1.5.0
Requires:         python-oslo-concurrency >= 3.8.0
Requires:         python-oslo-config >= 3.14.0
Requires:         python-oslo-context >= 2.6.0
Requires:         python-oslo-db >= 4.10.0
Requires:         python-oslo-i18n >= 2.1.0
Requires:         python-oslo-log >= 1.14.0
Requires:         python-oslo-messaging >= 5.2.0
Requires:         python-oslo-middleware >= 3.0.0
Requires:         python-oslo-policy >= 1.9.0
Requires:         python-oslo-privsep >= 1.9.0
Requires:         python-oslo-reports >= 0.6.0
Requires:         python-oslo-rootwrap >= 5.0.0
Requires:         python-oslo-serialization >= 1.10.0
Requires:         python-oslo-service >= 1.10.0
Requires:         python-oslo-utils >= 3.16.0
Requires:         python-oslo-versionedobjects >= 1.13.0
Requires:         python-os-vif >= 1.1.0
Requires:         python-oslo-vmware >= 1.16.0
Requires:         python-pbr
Requires:         python-posix_ipc
Requires:         python-psutil
Requires:         python-rfc3986
Requires:         python-six >= 1.9.0

%description -n   python-nova
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform.

This package contains the nova Python library.

%package -n python-nova-tests
Summary:        Nova tests
Requires:       openstack-nova = %{epoch}:%{version}-%{release}

%description -n python-nova-tests
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform.

This package contains the nova Python library.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Compute

BuildRequires:    graphviz

# Required to build module documents
BuildRequires:    python-boto
BuildRequires:    python-eventlet
BuildRequires:    python-barbicanclient
BuildRequires:    python-cinderclient
BuildRequires:    python-keystoneclient
BuildRequires:    python-neutronclient
BuildRequires:    python-os-win
BuildRequires:    python-oslo-config
BuildRequires:    python-oslo-log
BuildRequires:    python-oslo-messaging
BuildRequires:    python-oslo-policy
BuildRequires:    python-oslo-utils
BuildRequires:    python-oslo-vmware
BuildRequires:    python-redis
BuildRequires:    python-rfc3986
BuildRequires:    python-routes
BuildRequires:    python-sqlalchemy
BuildRequires:    python-webob
BuildRequires:    python-zmq
# while not strictly required, quiets the build down when building docs.
BuildRequires:    python-migrate, python-iso8601

%description      doc
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform.

This package contains documentation files for nova.
%endif

%prep
%setup -q -n nova-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1
%patch0071 -p1
%patch0072 -p1
%patch0073 -p1
%patch0074 -p1
%patch0075 -p1
%patch0076 -p1
%patch0077 -p1
%patch0078 -p1
%patch0079 -p1
%patch0080 -p1
%patch0081 -p1
%patch0082 -p1

find . \( -name .gitignore -o -name .placeholder \) -delete

find nova -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Remove the requirements file so that pbr hooks don't add it
# to distutils requiers_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires

%build
PYTHONPATH=. oslo-config-generator --config-file=etc/nova/nova-config-generator.conf

%{__python2} setup.py build

# Generate i18n files
%{__python2} setup.py compile_catalog -d build/lib/nova/locale

# Avoid http://bugzilla.redhat.com/1059815. Remove when that is closed
sed -i 's|group/name|group;name|; s|\[DEFAULT\]/|DEFAULT;|' etc/nova/nova.conf.sample

# Programmatically update defaults in sample config
# which is installed at /etc/nova/nova.conf

#  First we ensure all values are commented in appropriate format.
#  Since icehouse, there was an uncommented keystone_authtoken section
#  at the end of the file which mimics but also conflicted with our
#  distro editing that had been done for many releases.
sed -i '/^[^#[]/{s/^/#/; s/ //g}; /^#[^ ]/s/ = /=/' etc/nova/nova.conf.sample

#  TODO: Make this more robust
#  Note it only edits the first occurrence, so assumes a section ordering in sample
#  and also doesn't support multi-valued variables like dhcpbridge_flagfile.
while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" etc/nova/nova.conf.sample
done < %{SOURCE1}

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# docs generation requires everything to be installed first
export PYTHONPATH="$( pwd ):$PYTHONPATH"

# Remove this once sphinxcontrib.seqdiag becomes available
sed -i -e '/sphinxcontrib.seqdiag/d' doc/source/conf.py
sed -i -e 's#../../etc/nova/nova-config-generator.conf#etc/nova/nova-config-generator.conf#' doc/source/conf.py

%if 0%{?with_doc}
%{__python2} setup.py build_sphinx
%endif

%{__python2} setup.py build_sphinx --builder man
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 doc/build/man/*.1 %{buildroot}%{_mandir}/man1/

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/buckets
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/instances
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/keys
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/networks
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/tmp
install -d -m 750 %{buildroot}%{_localstatedir}/log/nova
install -d -m 700 %{buildroot}%{_sharedstatedir}/nova/.ssh

# Setup ghost CA cert
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/CA
install -p -m 755 nova/CA/*.sh %{buildroot}%{_sharedstatedir}/nova/CA
install -p -m 644 nova/CA/openssl.cnf.tmpl %{buildroot}%{_sharedstatedir}/nova/CA
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/CA/{certs,crl,newcerts,projects,reqs}
touch %{buildroot}%{_sharedstatedir}/nova/CA/{cacert.pem,crl.pem,index.txt,openssl.cnf,serial}
install -d -m 750 %{buildroot}%{_sharedstatedir}/nova/CA/private
touch %{buildroot}%{_sharedstatedir}/nova/CA/private/cakey.pem

# Install config files
install -d -m 755 %{buildroot}%{_sysconfdir}/nova
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datarootdir}/nova/nova-dist.conf
install -p -D -m 640 etc/nova/nova.conf.sample  %{buildroot}%{_sysconfdir}/nova/nova.conf
install -p -D -m 640 etc/nova/rootwrap.conf %{buildroot}%{_sysconfdir}/nova/rootwrap.conf
install -p -D -m 640 etc/nova/api-paste.ini %{buildroot}%{_sysconfdir}/nova/api-paste.ini
install -p -D -m 640 etc/nova/policy.json %{buildroot}%{_sysconfdir}/nova/policy.json
install -p -D -m 640 %{SOURCE33} %{buildroot}%{_sysconfdir}/httpd/conf.d/00-nova-placement-api.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration
install -p -D -m 600 %{SOURCE38} %{buildroot}%{_sysconfdir}/nova/migration/identity
install -p -D -m 644 %{SOURCE39} %{buildroot}%{_sysconfdir}/nova/migration/authorized_keys
install -p -D -m 640 %{SOURCE40} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d
install -p -D -m 640 %{SOURCE41} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters

# Install version info file
cat > %{buildroot}%{_sysconfdir}/nova/release <<EOF
[Nova]
vendor = %{distro}
product = OpenStack Compute
package = %{release}
EOF

# Install initscripts for Nova services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-nova-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-nova-cert.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/openstack-nova-compute.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/openstack-nova-network.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/openstack-nova-scheduler.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/openstack-nova-xvpvncproxy.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/openstack-nova-console.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/openstack-nova-consoleauth.service
install -p -D -m 644 %{SOURCE25} %{buildroot}%{_unitdir}/openstack-nova-metadata-api.service
install -p -D -m 644 %{SOURCE26} %{buildroot}%{_unitdir}/openstack-nova-conductor.service
install -p -D -m 644 %{SOURCE27} %{buildroot}%{_unitdir}/openstack-nova-cells.service
install -p -D -m 644 %{SOURCE28} %{buildroot}%{_unitdir}/openstack-nova-spicehtml5proxy.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/openstack-nova-novncproxy.service
install -p -D -m 644 %{SOURCE31} %{buildroot}%{_unitdir}/openstack-nova-serialproxy.service
install -p -D -m 644 %{SOURCE32} %{buildroot}%{_unitdir}/openstack-nova-os-compute-api.service

# Install sudoers
install -p -D -m 440 %{SOURCE24} %{buildroot}%{_sysconfdir}/sudoers.d/nova
install -p -D -m 440 %{SOURCE35} %{buildroot}%{_sysconfdir}/sudoers.d/nova_migration

# Install nova ssh client config for migration
install -p -D -m 600 %{SOURCE36} %{buildroot}%{_sharedstatedir}/nova/.ssh/config

# Install nova migration ssh wrapper command
install -p -D -m 755 %{SOURCE37} %{buildroot}%{_bindir}/nova-migration-wrapper

# Install logrotate
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-nova

# Install pid directory
install -d -m 755 %{buildroot}%{_localstatedir}/run/nova

# Install template files
install -p -D -m 644 nova/cloudpipe/client.ovpn.template %{buildroot}%{_datarootdir}/nova/client.ovpn.template
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_datarootdir}/nova/interfaces.template

# Install rootwrap files in /usr/share/nova/rootwrap
mkdir -p %{buildroot}%{_datarootdir}/nova/rootwrap/
install -p -D -m 644 etc/nova/rootwrap.d/* %{buildroot}%{_datarootdir}/nova/rootwrap/

# Older format. Remove when we no longer want to support Fedora 17 with master branch packages
install -d -m 755 %{buildroot}%{_sysconfdir}/polkit-1/localauthority/50-local.d
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_sysconfdir}/polkit-1/localauthority/50-local.d/50-nova.pkla
# Newer format since Fedora 18
install -d -m 755 %{buildroot}%{_sysconfdir}/polkit-1/rules.d
install -p -D -m 644 %{SOURCE23} %{buildroot}%{_sysconfdir}/polkit-1/rules.d/50-nova.rules

# Install novncproxy service options template
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 0644 %{SOURCE30} %{buildroot}%{_sysconfdir}/sysconfig/openstack-nova-novncproxy

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python2_sitelib}/nova/locale/*/LC_*/nova*po
rm -f %{buildroot}%{python2_sitelib}/nova/locale/*pot
mv %{buildroot}%{python2_sitelib}/nova/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang nova --all-name

# Remove unneeded in production stuff
rm -f %{buildroot}%{_bindir}/nova-debug
rm -fr %{buildroot}%{python2_sitelib}/run_tests.*
rm -f %{buildroot}%{_bindir}/nova-combined
rm -f %{buildroot}/usr/share/doc/nova/README*

%pre common
getent group nova >/dev/null || groupadd -r nova --gid 162
if ! getent passwd nova >/dev/null; then
  useradd -u 162 -r -g nova -G nova,nobody -d %{_sharedstatedir}/nova -s /sbin/nologin -c "OpenStack Nova Daemons" nova
fi
exit 0

%pre compute
usermod -a -G qemu nova
%pre migration
getent group nova_migration >/dev/null || groupadd -r nova_migration
getent passwd nova_migration >/dev/null || \
    useradd -r -g nova_migration -d / -s /bin/bash -c "OpenStack Nova Migration" nova_migration
exit 0

%post compute
%systemd_post %{name}-compute.service
%post network
%systemd_post %{name}-network.service
%post scheduler
%systemd_post %{name}-scheduler.service
%post cert
%systemd_post %{name}-cert.service
%post api
%systemd_post %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service
%post conductor
%systemd_post %{name}-conductor.service
%post console
%systemd_post %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%post cells
%systemd_post %{name}-cells.service
%post novncproxy
%systemd_post %{name}-novncproxy.service
%post spicehtml5proxy
%systemd_post %{name}-spicehtml5proxy.service
%post serialproxy
%systemd_post %{name}-serialproxy.service

%preun compute
%systemd_preun %{name}-compute.service
%preun network
%systemd_preun %{name}-network.service
%preun scheduler
%systemd_preun %{name}-scheduler.service
%preun cert
%systemd_preun %{name}-cert.service
%preun api
%systemd_preun %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service
%preun conductor
%systemd_preun %{name}-conductor.service
%preun console
%systemd_preun %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%preun cells
%systemd_preun %{name}-cells.service
%preun novncproxy
%systemd_preun %{name}-novncproxy.service
%preun spicehtml5proxy
%systemd_preun %{name}-spicehtml5proxy.service
%preun serialproxy
%systemd_preun %{name}-serialproxy.service

%postun compute
%systemd_postun_with_restart %{name}-compute.service
%postun network
%systemd_postun_with_restart %{name}-network.service
%postun scheduler
%systemd_postun_with_restart %{name}-scheduler.service
%postun cert
%systemd_postun_with_restart %{name}-cert.service
%postun api
%systemd_postun_with_restart %{name}-api.service %{name}-metadata-api.service %{name}-os-compute-api.service
%postun conductor
%systemd_postun_with_restart %{name}-conductor.service
%postun console
%systemd_postun_with_restart %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%postun cells
%systemd_postun_with_restart %{name}-cells.service
%postun novncproxy
%systemd_postun_with_restart %{name}-novncproxy.service
%postun spicehtml5proxy
%systemd_postun_with_restart %{name}-spicehtml5proxy.service
%postun serialproxy
%systemd_postun_with_restart %{name}-serialproxy.service

%files
%doc LICENSE
%{_bindir}/nova-all

%files common -f nova.lang
%doc LICENSE
%dir %{_datarootdir}/nova
%attr(-, root, nova) %{_datarootdir}/nova/nova-dist.conf
%{_datarootdir}/nova/client.ovpn.template
%{_datarootdir}/nova/interfaces.template
%{_datarootdir}/nova/rootwrap/network.filters
%dir %{_sysconfdir}/nova
%{_sysconfdir}/nova/release
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/nova.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/api-paste.ini
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/rootwrap.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/policy.json
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-nova
%config(noreplace) %{_sysconfdir}/sudoers.d/nova
%config(noreplace) %{_sysconfdir}/polkit-1/localauthority/50-local.d/50-nova.pkla
%config(noreplace) %{_sysconfdir}/polkit-1/rules.d/50-nova.rules

%dir %attr(0750, nova, root) %{_localstatedir}/log/nova
%dir %attr(0755, nova, root) %{_localstatedir}/run/nova

%{_bindir}/nova-manage
%{_bindir}/nova-policy
%{_bindir}/nova-rootwrap
%{_bindir}/nova-rootwrap-daemon

%{_mandir}/man1/nova*.1.gz

%defattr(-, nova, nova, -)
%dir %{_sharedstatedir}/nova
%dir %{_sharedstatedir}/nova/buckets
%dir %{_sharedstatedir}/nova/instances
%dir %{_sharedstatedir}/nova/keys
%dir %{_sharedstatedir}/nova/networks
%dir %{_sharedstatedir}/nova/tmp

%files compute
%{_bindir}/nova-compute
%{_bindir}/nova-idmapshift
%{_unitdir}/openstack-nova-compute.service
%{_datarootdir}/nova/rootwrap/compute.filters

%files network
%{_bindir}/nova-network
%{_bindir}/nova-dhcpbridge
%{_unitdir}/openstack-nova-network.service

%files scheduler
%{_bindir}/nova-scheduler
%{_unitdir}/openstack-nova-scheduler.service

%files cert
%{_bindir}/nova-cert
%{_unitdir}/openstack-nova-cert.service
%defattr(-, nova, nova, -)
%dir %{_sharedstatedir}/nova/CA/
%dir %{_sharedstatedir}/nova/CA/certs
%dir %{_sharedstatedir}/nova/CA/crl
%dir %{_sharedstatedir}/nova/CA/newcerts
%dir %{_sharedstatedir}/nova/CA/projects
%dir %{_sharedstatedir}/nova/CA/reqs
%{_sharedstatedir}/nova/CA/*.sh
%{_sharedstatedir}/nova/CA/openssl.cnf.tmpl
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/cacert.pem
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/crl.pem
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/index.txt
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/openssl.cnf
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/serial
%dir %attr(0750, -, -) %{_sharedstatedir}/nova/CA/private
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/private/cakey.pem

%files api
%{_bindir}/nova-api*
%{_unitdir}/openstack-nova-*api.service
%{_datarootdir}/nova/rootwrap/api-metadata.filters

%files conductor
%{_bindir}/nova-conductor
%{_unitdir}/openstack-nova-conductor.service

%files console
%{_bindir}/nova-console*
%{_bindir}/nova-xvpvncproxy
%{_unitdir}/openstack-nova-console*.service
%{_unitdir}/openstack-nova-xvpvncproxy.service

%files cells
%{_bindir}/nova-cells
%{_unitdir}/openstack-nova-cells.service

%files novncproxy
%{_bindir}/nova-novncproxy
%{_unitdir}/openstack-nova-novncproxy.service
%config(noreplace) %{_sysconfdir}/sysconfig/openstack-nova-novncproxy

%files spicehtml5proxy
%{_bindir}/nova-spicehtml5proxy
%{_unitdir}/openstack-nova-spicehtml5proxy.service

%files serialproxy
%{_bindir}/nova-serialproxy
%{_unitdir}/openstack-nova-serialproxy.service

%files placement-api
%config(noreplace) %{_sysconfdir}/httpd/conf.d/00-nova-placement-api.conf
%{_bindir}/nova-placement-api

%files migration
%{_bindir}/nova-migration-wrapper
%config(noreplace) %{_sysconfdir}/sudoers.d/nova_migration
%dir %attr(0700, nova, nova) %{_sharedstatedir}/nova/.ssh
%attr(0600, nova, nova) %{_sharedstatedir}/nova/.ssh/config
%dir %{_sysconfdir}/nova/migration
%config(noreplace) %attr(0640, root, nova_migration) %{_sysconfdir}/nova/migration/authorized_keys
%config(noreplace) %attr(0600, nova, nova) %{_sysconfdir}/nova/migration/identity
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.conf
%dir %{_sysconfdir}/nova/migration/rootwrap.d
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters

%files -n python-nova
%doc LICENSE
%{python2_sitelib}/nova
%{python2_sitelib}/nova-*.egg-info
%exclude %{python2_sitelib}/nova/tests

%files -n python-nova-tests
%license LICENSE
%{python2_sitelib}/nova/tests

%if 0%{?with_doc}
%files doc
%doc LICENSE doc/build/html
%endif

%changelog
* Wed Nov 28 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-35
- LM: Make quick-fail on CPU pinning conflict configurable (rhbz#1613242)
- Consider hostdev devices when building metadata (rhbz#1532683)
- Refactor _build_device_metadata (rhbz#1532683)
- hardware: fix memory check usage for small/large pages (rhbz#1519540)
- hardware: fix hugepages memory usage per intances (rhbz#1519540)
- Handle volume API failure in _post_live_migration (rhbz#1636102)
- Prepare functional tests for live migration support
- libvirt: check image type before removing snapshots in _cleanup_resize (rhbz#1633117)
- libvirt: do not remove inst_base when volume-backed during resize (rhbz#1633117)
- Ensure that instance directory is removed after success migration/resize (rhbz#1633117)
- Add context param to confirm_migration virt call (rhbz#1633117)
- libvirt: Rename Backend snapshot and image (rhbz#1633117)
- vif: allow for creation of multiqueue taps in vrouter (rhbz#1608521)
- linux_net: allow for creation of multiqueue taps (rhbz#1608521)

* Wed Nov 28 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-34
- Support qemu >= 2.10 (rhbz#1646382)

* Thu Sep 06 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-27
- libvirt: skip setting rx/tx queue sizes for not virto interfaces (rhbz#1625180)

* Fri Aug 17 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-26
- Revert "libvirt: slow live-migration to ensure network is ready" (rhbz#1563101)

* Thu Aug 02 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-25
- add mtu to libvirt xml for ethernet and bridge types (rhbz#1553559)

* Thu Jul 05 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-24
- libvirt: slow live-migration to ensure network is ready (rhbz#1563101)
- conf: Allow users to unset 'keymap' options (rhbz#1441962)
- Add CPUWeigher (rhbz#1565089)

* Mon Jun 11 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-23
- libvirt: Block swap volume attempts with encrypted volumes prior to Queens (rhbz#1547023)
- Refactor a test method including 3 test cases (rhbz#1547023)

* Mon May 14 2018 Kashyap Chamarthy <kchamart@redhat.com> 1:14.1.0-22
- libvirt: Lift the restriction of choices for `cpu_model_extra_flags`
  (rhbz#1577133)
- libvirt: Make `cpu_model_extra_flags` case-insensitive for real
  (rhbz#1576809)

* Thu May 10 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-21
- libvirt: fix setting tx_queue_size when rx_queue_size is not set (rhbz#1573803)

* Wed May 09 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-20
- conf: Remove duplicate oslo_config types import (rhbz#1575989)

* Tue May 01 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-19
- libvirt: Report the allocated size of preallocated file based disks (rhbz#1569953)

* Fri Apr 27 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-18
- libvirt: add support for virtio-net rx/tx queue sizes (rhbz#1570949)
- libvirt: fix wrong driver name for vhostuser interface (rhbz#1570949)
- libvirt: refactor get_base_config to accept host arg (rhbz#1570949)
- libvirt: move version to string in utils (rhbz#1570949)
- libvirt: Allow to specify granular CPU feature flags (rhbz#1570617)

* Mon Apr 23 2018 Artom Lifshitz <alifshit@redhat.com> 1:14.1.0-17
- only increment disk address unit for scsi devices (rhbz#1546965)

* Wed Mar 28 2018 melanie witt <melwitt@redhat.com> 1:14.1.0-16
- Save admin password to sysmeta in libvirt driver (rhbz#1542342)

* Wed Mar 28 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-15
- Use proper user and tenant in the owner section of libvirt.xml. (rhbz#1558103)

* Mon Mar 19 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-14
- Avoid lazy-load error when getting instance AZ (rhbz#1538092)

* Fri Mar 16 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-13
- Revert "Refine waiting for vif plug events during _hard_reboot" (rhbz#1556855)

* Fri Mar 09 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-12
- Do not attempt volume swap when guest is stopped/suspended (rhbz#1545269)
- Refactor a test method including 7 test cases (rhbz#1545269)

* Fri Feb 23 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-11
- libvirt: disconnect volume from host during detach (rhbz#1505595)

* Wed Feb 21 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-10
- live-mig: keep disk device address same (rhbz#1542795)

* Wed Feb 14 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-9
- libvirt: prefer cinder rbd auth values over nova.conf (rhbz#1510339)
- libvirt: cleanup network volume driver auth config (rhbz#1510339)

* Sat Feb 10 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-8
- Do not attempt to load osinfo if we do not have os_distro (rhbz#1506583)

* Sat Feb 10 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-7
- Refine waiting for vif plug events during _hard_reboot (rhbz#1543019)

* Fri Feb 09 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-6
- Save updated libvirt domain XML after swapping volume (rhbz#1534776)

* Thu Feb 08 2018 Lee Yarwood <lyarwood@redhat.com> 1:14.1.0-5
- Don't wait for vif plug events during _hard_reboot (rhbz#1543019)
- libvirt: Re-initialise volumes, encryptors, and vifs on hard reboot (rhbz#1543019)
- libvirt: Test disk creation in test_hard_reboot (rhbz#1543019)

* Wed Jan 31 2018 Matthew Booth <mbooth@redhat.com> 1:14.1.0-4
- libvirt: Don't VIR_MIGRATE_NON_SHARED_INC without migrate_disks (rhbz#1537069)
- libvirt: bandwidth param should be set in guest migrate (rhbz#1537069)

* Wed Jan 24 2018 melanie witt <melwitt@redhat.com> 1:14.1.0-3
- Set server status to ERROR if rebuild failed (rhbz#1536173)
- Fixes 'Not enough available memory' log message (rhbz#1519054)

* Mon Jan 22 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.1.0-2
- Add format_dom for PCI device addresses (rhbz#1527345)

* Mon Jan 15 2018 Steve Linabery <slinaber@redhat.com> 1:14.1.0-1
- Update to 14.1.0

* Mon Jan 15 2018 Steve Linabery <slinaber@redhat.com> 1:14.0.10-1
- Update to 14.0.10

* Mon Jan 15 2018 Artom Lifshitz <alifshit@redhat.com> 1:14.0.9-6
- Get original image_id from volume for volume-backed instance rebuild (rhbz#1508690)
- Only query BDMs once in API during rebuild (rhbz#1508690)
- Add regression test for rebuilding a volume-backed server (rhbz#1508690)
- Refined fix for validating image on rebuild (rhbz#1508690)
- Validate new image via scheduler during rebuild (rhbz#1508690)
- Fix non-parameterized service id in hypervisors sample tests (rhbz#1508690)

* Thu Jan 11 2018 Matthew Booth <mbooth@redhat.com> 1:14.0.9-5
- Fix disk size during live migration with disk over-commit (rhbz#1530330)

* Tue Jan 02 2018 Artom Lifshitz <alifshit@redhat.com> 1:14.0.9-4
- Make request_spec.spec MediumText (rhbz#1526082)

* Fri Nov 24 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.9-3
- scheduler: quick-fail on CPUs pinning conflicts during migration

* Wed Nov 22 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.9-2
- libvirt: fix vCPU usage reporing for LXC/QEMU guests (rhbz#1515165)
- libvirt: remove hack for dom.vcpus() returning None (rhbz#1515165)

* Wed Nov 01 2017 melanie witt <melwitt@redhat.com> 1:14.0.9-1
- Update to 14.0.9 (rhbz#1501736)

* Mon Oct 23 2017 Steve Linabery <slinaber@redhat.com> 1:14.0.8-5
- Catch InstanceNotFound exception
- Account for compute.metrics.update in legacy notification whitelist
- Add live.migration.force.complete to the legacy notification whitelist
- Fix --max-count handling for nova-manage cell_v2 map_instances
- neutron: handle binding:profile=None during migration
- Provide original fault message when BFV fails

* Wed Sep 27 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.8-4
- libvirt: update the logic to configure volume with scsi controller (rhbz#1495158)
- libvirt: update logic to configure device for scsi controller (rhbz#1495158)
- libvirt: rearange how scsi controller is defined (rhbz#1495158)
- libvirt: set full description of the controller used by disk (rhbz#1495158)
- libvirt: update LibvirtConfigGuestDeviceAddress to provide XML (rhbz#1495158)

* Sun Sep 24 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.8-3
- ovs-hybrid: should permanently keep MAC entries (rhbz#1494983)
- libvirt: remove redundant and broken iscsi volume test (rhbz#1493055 rhbz#1484496)
- Make unit tests work with os-vif 1.4.0 (rhbz#1471657 rhbz#1487687 rhbz#1471657)

* Thu Aug 31 2017 Jason Joyce <jjoyce@redhat.com> 1:14.0.8-2
- Rootwrap rule names for migration whitelisted commands must be unique (rhbz#1487269)
- Whitelist all possible nova migration scp commands (rhbz#1487269)

* Mon Aug 28 2017 melanie witt <melwitt@redhat.com> 1:14.0.8-1
- Update to 14.0.8 (rhbz#1475611)

* Fri Aug 04 2017 Jason Joyce <jjoyce@redhat.com> 1:14.0.7-11
- Fix regression preventing reporting negative resources for overcommit

* Thu Aug 03 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.7-10
- Pass MTU into os-vif Network object (rhbz#1468620)
- network: remove support of vhost fast path (rhbz#1458177)
- Revert MTU hacks for bug 1623876 (rhbz#1468620)

* Mon Jul 17 2017 Jon Schlueter <jschluet@redhat.com> 1:14.0.7-9
- make sure to rebuild claim on recreate (rhbz#1464391)
- neutron: retrieve physical network name from a multi-provider network (rhbz#1422129)
- contrail: add vrouter VIF plugin type support (rhbz#1458177)
- os-vif: convert libvirt driver to use os-vif for fast path vhostuser (rhbz#1458177)
- libvirt: Fix races with nfs volume mount/umount
- libvirt: Pass instance to connect_volume and disconnect_volume (rhbz#1454798)
- libvirt: Call host connection callbacks asynchronously (rhbz#1454798)
- libvirt: Pass Host instead of Driver to volume drivers (rhbz#1454798)
- Use VIR_DOMAIN_BLOCK_REBASE_COPY_DEV when rebasing
- libvirt: Always disconnect_volume after rebase failures (rhbz#1438320)
- Exclude deleted service records when calling hypervisor statistics (rhbz#1458190)
- Update to 14.0.7 (rhbz#1455893)
- Correct _ensure_console_log_for_instance implementation (rhbz#1386420)

* Mon Jul 17 2017 Artom Lifshitz <alifshit@redhat.com> 1:14.0.6-2.1
- Add explicit requirement on libvirt-client (rhbz#1463621)

* Tue May 23 2017 Mike Burns <mburns@redhat.com> 1:14.0.6-2
- Readd old patches to 14.0.6

* Tue May 23 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.6-1
- Update to 14.0.6

* Tue May 23 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.5-1
- Update to 14.0.5

* Fri May 12 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.4-8
- Fixed suspend for PCI passthrough (rhbz#1448002)

* Tue May 09 2017 Artom Lifshitz <alifshit@redhat.com> 1:14.0.4-7
- Ignore IOError when creating 'console.log' (rhbz#1386420)

* Tue May 02 2017 Mike Burns <mburns@redhat.com> 1:14.0.4-6
- Update to 14.0.4 rhbz#1429924
- libvirt: Remove redundant bdm serial mangling and saving during swap_volume (rhbz#1420760)
- rebase to upstream/stable/newton (rhbz#1431802)
- Add release note for live_migration_progress_timeout issue
- Ignore deleted services in minimum version calculation
- Imported Translations from Zanata
- Pre-load info_cache when handling external events and handle NotFound
- Do not post allocations that are zero
- placement: Do not save 0-valued inventory
- [placement] Enforce min_unit, max_unit and step_size
- Correct wrong max_unit in placement inventory
- placement: genericize on resource providers
- placement: refactor instance translate function
- placement: refactor translate from node to dict
- do not include context to exception notification (rhbz#1436946)

* Tue May 02 2017 Alex Schultz <aschultz@redhat.com> 1:14.0.3-9
- Add package for Nova migration SSH config (rhbz#1428241)

* Tue Feb 07 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.3-8
- libvirt: workaround findmnt behaviour change (rhbz#1412454)
- Catch error and log warning when not able to update mtimes (rhbz#1412454)

* Fri Feb 03 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.3-7
- libvirt: Limit destroying disks during cleanup to spawn (rhbz#1354601)

* Tue Jan 31 2017 Stephen Finucane <sfinucan@redhat.com> 1:14.0.3-6
- scheduler: Don't modify RequestSpec.numa_topology (rhbz#1417617)

* Mon Jan 30 2017 Artom Lifshitz <alifshit@redhat.com> 1:14.0.3-5
- libvirt: avoid generating script with empty path (rhbz#1408464)

* Wed Jan 25 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.3-4
- libvirt: Detach volumes from a domain before detaching any encryptors (rhbz#1388417)

* Thu Jan 19 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.3-3
- Removal of tests with different result depending on testing env (rhbz#1414859)

* Thu Jan 19 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.3-2
- convert libvirt driver to use os-vif for vhost-user with ovs. (rhbz#1410351)
- add host to vif.py set_config_* functions (rhbz#1410351)

* Fri Jan 06 2017 Jon Schlueter <jschluet@redhat.com> 1:14.0.3-1
- Update to 14.0.3 (rhbz#1410838)

* Thu Jan 05 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.2-12
- Cleanup after any failed libvirt spawn (rhbz#1354601)

* Wed Jan 04 2017 Kashyap Chamarthy <kchamart@redhat.com> 1:14.0.2-11
- Bump prlimit cpu time for qemu from 2 to 8 (rhbz#1404651)

* Wed Jan 04 2017 Lee Yarwood <lyarwood@redhat.com> 1:14.0.2-10
- Fix crashing during guest config with pci_devices=None (rhbz#1403380)

* Wed Dec 21 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.2-9
- Explicitly add libosinfo as a required dependency for compute RPM (rhbz#1361210)

* Wed Dec 21 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.2-8
- libvirt: prepare domain XML update for serial ports (rhbz#1396867)
- libvirt: do not return serial address if disabled on destination (rhbz#1396867)
- libvirt: Acquire TCP ports for console during live migration (rhbz#1396867)
- libvirt: refactor console device creation methods (rhbz#1396867)
- Fill destination check data with VNC/SPICE listen addresses (rhbz#1396867)

* Mon Nov 21 2016 Jason Joyce <jjoyce@redhat.com> 1:14.0.2-7
- Add flavor extra_spec info link to api_ref
- encryptors: Workaround mangled passphrases

* Thu Nov 17 2016 Jason Joyce <jjoyce@redhat.com> 1:14.0.2-6
- Instance obj_clone leaves metadata as changed
- Set 'last_checked' flag if start to check scheduler file
- Add a no-op wait method to NetworkInfo
- Update docs for serial console support

* Wed Nov 09 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.2-5
- libvirt: fix serial console not correctly defined after live-migration (rhbz#1392830)

* Wed Nov 09 2016 Jon Schlueter <jschluet@redhat.com> 1:14.0.2-4
- Send events to all relevant hosts if migrating

* Tue Nov 08 2016 Vladik Romanovsky <vromanso@redhat.com> 1:14.0.2-3
- libvirt: sync time on resumed from suspend instances (rhbz#1390576)

* Mon Nov 07 2016 Jon Schlueter <jschluet@redhat.com> 1:14.0.2-2
- Update instance node on rebuild only when it is recreate

* Mon Nov 07 2016 Alfredo Moralejo <amoralej@redhat.com> 1:14.0.2-1
- Update to 14.0.2

* Mon Nov 07 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:14.0.1-6
- libvirt: fix incorrect host cpus giving to emulator threads when RT (rhbz#1392367)
- PCI: Fix PCI with fully qualified address (rhbz#1390576)

* Fri Oct 28 2016 Jon Schlueter <jschluet@redhat.com> 1:14.0.1-5
- Imported Translations from Zanata
- Fix issue with not removing rbd rescue disk

* Mon Oct 24 2016 Jon Schlueter <jschluet@redhat.com> 1:14.0.1-4
- Fix exception due to BDM race in get_available_resource()

* Wed Oct 19 2016 Jon Schlueter <jschluet@redhat.com> 1:14.0.1-3
- Add InvalidInput handling for attach-volume
- Fix exception when vcpu_pin_set is set to ""
- releasenote: WebOb<1.6.0 placement API known issue
- Don't attempt to escalate nova-manage privileges
- Avoid update resource if compute node not updated
- Change log level to debug for migrations pairing
- Fix drop_move_claim() on revert resize
- Catch DevicePathInUse in attach_volume
- HyperV: ensure config drives are copied as well during resizes

* Mon Oct 17 2016 Lee Yarwood <lyarwood@redhat.com> 1:14.0.1-2
- Do not try to backport when db has older object version (rhbz#1385500)

* Wed Oct 12 2016 Lee Yarwood <lyarwood@redhat.com> 1:14.0.1-1
- Update to 14.0.1 (rhbz#1383954)

* Thu Oct 06 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:14.0.0-1
- Update to 14.0.0

* Thu Sep 29 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:14.0.0-0.3.0rc2
- Update to 14.0.0.0rc2

* Wed Sep 21 2016 Alfredo Moralejo <amoralej@redhat.com> 1:14.0.0-0.2.0rc1
- Update to 14.0.0.0rc1

* Wed Sep 14 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:14.0.0-0.1.0b3
- Update to 14.0.0.0b3
